<?php



class WRLoginLock
{

    var $max_inactivity;
    var $warn_before = 30;
    var $pluginName = 'loginlocker';
    var $lockFile = '';
    var $status = 'logged-out';
    var $version = '1.0 Beta';



    function WRLoginLock($action = null)
    {
        global $plugin_cf;

        $this->max_inactivity = (int) $plugin_cf[$this->pluginName]['max_inactivity'] >= 60 ? (int) $plugin_cf[$this->pluginName]['max_inactivity'] : 60;

        if (
                isset($plugin_cf[$this->pluginName]['warn_before'])
                && (int) $plugin_cf[$this->pluginName]['warn_before'] > 0
                && $plugin_cf[$this->pluginName]['warn_before'] < $plugin_cf[$this->pluginName]['max_inactivity']
        )
        {
            $this->warn_before = $plugin_cf[$this->pluginName]['warn_before'];
        }

        $this->lockFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'lock.txt';
        $this->status = $this->isLoggedIn() ? 'logged-in' : 'logged-out';
    }



    function isLoggedIn()
    {
        if (isset($_COOKIE['lastAction']) && time() < $_COOKIE['lastAction'] + $this->max_inactivity)
        {
            return true;
        }
        return false;
    }



    function isLocked()
    {
        if (time() > fileatime($this->lockFile) + $this->max_inactivity)
        {
            return false;
        }
        if (array_pop(file($this->lockFile)) === 'logged-out')
        {
            return false;
        }
        return true;
    }



    function writeLog()
    {
        $fh = fopen($this->lockFile, 'w');
        if ($fh)
        {
            fwrite($fh, $this->status);
            fclose($fh);
            return;
        }
        $this->error('Plugin LoginLocker: Lock-Datei konnte nicht beschrieben werden.');
    }



    function logOut($writeLog = true)
    {
        global $sn, $u;
        $this->status = 'logged-out';
        setcookie('status', '', 1);
        setcookie('passwd', '', 1);
        session_destroy();
        $this->writeLog();
        if (!isset($_GET['logout']))
        {

            header('Location: ' . $sn . '?' . $u[0] . '&logged-out&logout');
            exit;
        }
    }



    function logIn()
    {

        $this->status = 'logged-in';
        $this->writeLog();
        $this->touch();
    }



    function touch()
    {
        touch($this->lockFile);
        setcookie('lastAction', time());
    }



    function error($message, $args = null)
    {
        global $o, $e;
        $o .= '<p class="cmsimplecore_warning" style="text-align: center;">' . $this->translate($message, $args) . '</p>' . "\n";
    }



    function translate($message, $args = null)
    {
        global $plugin_tx;

        $message = isset($plugin_tx[$this->pluginName][$message]) ? $plugin_tx[$this->pluginName][$message] : '{' . $message . '}';
        if (is_array($args) && count($args) > 0)
        {
            array_unshift($args, $message);
            $message = call_user_func_array('sprintf', $args);
        }
        if (is_string($args) && strlen($args) > 0)
        {
            $message = sprintf($message, $args);
        }
        return $message;
    }


}

?>
